createListener =
    function(methods, jinterface, jname = "",
             superClass = "org.omegahat.R.Java.RJavaInstance")
{
    jinterface = sapply(jinterface, expandClassName)
    if(is.null(jname) || jname == "")
        jname = gsub(".*\\.", "R", jinterface[1])

    compiler <- .JavaConstructor("ForeignReferenceClassGenerator",
                                 jinterface, jname)
    if(superClass != "") 
        compiler$superClassName(expandClassName(superClass))

    dyn <- .Java("__Evaluator","dynamicClassLoader")
    klass = .Java(dyn,"defineClass", compiler)

    if(!is.null(methods)) {
        if(inherits(methods, "AnonymousReference"))
            ref = methods
        else
            ref = foreignReference(methods) 
        l <- .JNew(jname, ref, .convert = FALSE)
        list(listener = l, reference = ref)
    } else {
        klass
    }
}
