#
# The idea is to take a collection of methods
# from a Java interface and provide a template or
# skeleton of the corresponding R closure that would 
# implement these.

interfaceGenerator <- function(name, file = "")
{
    jmethods <- getJavaMethods(name)

    cat("## Template implementation of R closure for Java interface\n##",
        name, "\n\n", file=file)
    cat(paste(name, "generator", sep="."), file=file, append=TRUE)
    cat(" <- function() {\n\n", file=file, append=TRUE)
    for(i in jmethods) {
        cat(" ", i$name, " <- function(", file=file, append = TRUE)
        if(length(i$Parameters) > 0)
            cat(paste(letters[1:length(i$Parameters)],sep=", "),
                file=file,append = TRUE)
        cat(")  {\n  }\n\n", file=file, append = TRUE)
        cat("  attributes(",i$name,")$jsignature <- ",
            paste("\"", paste(i$Parameters,sep=","),"\"",sep="") ,
            file=file, append = TRUE)
        cat("\n\n", file=file, append = TRUE)
    }

    mnames <- sapply(jmethods, function(x) x$name)

    cat("  return(list(",paste(mnames,mnames,sep="=", collapse=", "), "))",
        file=file, append = TRUE)

    cat("\n\n} # end of closure\n\n", file = file,append = TRUE)
}
