
#
# These are convenience methods for 
# accessing (calling) Java methods and fields.
# It uses the $ operator
#
# Obviously we should have AnonymousOmegahatReference
# and NamedOmegahatReference should inherit from a common
# base class and this $ method should be defined for it.

"$.OmegahatReference" <-
function(obj,name)
{
 function(...) {
  .Java(obj, as.character(name),...)
 }
}


"[.JavaArrayReference" <-
function(x, ...)
{
  .JavaGetArrayElement(x, ...)
}


"[<-.JavaArrayReference" <-
function(x, ..., value)
{
  .JavaSetArrayElement(x, value = value, ...)
}

length.JavaArrayReference <-
function(x)
{
  .Java("java.lang.reflect.Array", "getLength", x) 
}  


"[[.OmegahatReference" <-
function(x, name, ...)
{
  .Java(NULL, "getField", name, x, FALSE, ...)
}

"[[<-.OmegahatReference" <-
function(x, name, ..., value)
{
  .Java(NULL, "setField", name, x, value, ...)
}

print.OmegahatReference <-
function(x, ...)
{
    cat("class:", class(x)[[1]], "\n")
    obj <- unclass(x)                   # no dispatch
    cat("class name:", obj[["className"]], "\n")
    cat("key:", obj[["key"]], "\n")
}
