package org.omegahat.R.Java.Examples;
/**
 A class that tests the R foreign reference for a 
 DataFrameInt by calling the different methods
 of the interface and calling the corresponding R
 functions. This is intended to mimic what happens
 with DataFrameTableModel but from within one thread.
*/

import org.omegahat.DataStructures.Data.*;

public class TestDataFrame {

 public boolean verbose = false;

 public TestDataFrame() {
 }

 public TestDataFrame(DataFrameInt df) {
   test(df, 10);
 }

 public TestDataFrame(DataFrameInt df, boolean verbose) {
   this.verbose = verbose;
   test(df, 10);
 }

 public boolean test(DataFrameInt df, int numTimes) {

   for(int i = 0; i < numTimes ; i++) {
     test(df);
   }
  return(true);
 }

 public boolean test(DataFrameInt df) {

  VariableInt var;
  int nobs, i;

  String[] names = df.getVariableNames();
  int numVars = (int) df.numVariables();
  String name = df.getName();
  nobs = (int) df.numObservations();

  System.err.println("Data frame: " + name + " # obs" + nobs + " # variables" +  numVars);

  for(i = 0;i<names.length; i++) {
    var = df.getVariable(names[i]);
    nobs = (int) var.numObservations();
   if(verbose)
     System.err.println(i +") " + names[i] + " " + nobs);
  }

  String[] rowNames = df.rowNames();
  for(i = 0; i < rowNames.length; i++) {
   if(verbose) {
     System.err.print(rowNames[i] + " ");
     if(i%5 == 0)
       System.err.print("\n<" + i + ">");
   }
  }

  return(true);
 }


}
