\name{convertFromToJava}

\alias{convertListToJava}
\alias{convertNamedListToJava}
\alias{convertArrayFromJava}
\alias{convertOrderedTableFromJava}
\alias{convertVectorFromJava}
\alias{simplifyListToVector}
\alias{setDefaultConverters}

\title{Convert Java instance to R instances and vice versa}

\description{

  These functions convert Java language structures (e.g., a Java vector)
  to the corresponding R structure (e.g., an R vector).

}

\usage{
convertListToJava(x, ...)
convertNamedListToJava(x, ...)
convertArrayFromJava(x, ...)
convertOrderedTableFromJava(x, ...)
convertVectorFromJava(x, ...)
simplifyListToVector(x)
setDefaultConverters()
}

\arguments{

  \item{x}{The R object or Java reference to be convereted or
    simplified.}

  \item{\dots}{Additional (unused) arguments.}

}

\value{

  The \code{convert} functions return the converted R or Java
  object. \code{setDefaultConverters} sets the converts enumerated here
  as the default for the corresponding data types.

}

\references{\url{http://www.omegahat.org}, \url{http://www.javasoft.com}}

\author{Duncan Temple Lang}

\keyword{programming}
\keyword{interface}
