/* #line 168 "RStoJava.cweb" */
#ifndef RSTOJAVA_H
#define RSTOJAVA_H

#include "RSCommon.h"

#ifdef _R_
#include "RtoJava.h"
#endif

#include <jni.h>


/* #line 354 "RStoJava.cweb" */
USER_OBJECT_
RS_ConstructorJavaCall(USER_OBJECT_ className, USER_OBJECT_ args,
                       USER_OBJECT_ argNames, USER_OBJECT_ returnValueName,
                       USER_OBJECT_ signatures, USER_OBJECT_ convert);

/* #line 447 "RStoJava.cweb" */
USER_OBJECT_
RS_OmegahatExpression(USER_OBJECT_ expressionString,
                      USER_OBJECT_ userArgs, USER_OBJECT_ userArgNames,
                      USER_OBJECT_ returnValueName,
                      USER_OBJECT_ signatures, USER_OBJECT_ convert);

/* #line 499 "RStoJava.cweb" */
USER_OBJECT_
convertAnswer(JNIEnv *env, USER_OBJECT_ returnValueName, jobject val, USER_OBJECT_ converter);


/* #line 596 "RStoJava.cweb" */
jobjectArray
argsToArray(JNIEnv *env, USER_OBJECT_ userArgs, USER_OBJECT_ signatures);

/* #line 636 "RStoJava.cweb" */
jobjectArray
argNamesToArray(JNIEnv *env, USER_OBJECT_ userArgNames, int addExtraValue);

/* #line 685 "RStoJava.cweb" */
jobjectArray
JavaObjectArray(JNIEnv *env, int length);

/* #line 710 "RStoJava.cweb" */
jobjectArray
JavaStringArray(JNIEnv *env, int length);

/* #line 742 "RStoJava.cweb" */
JNIEnv *SgetJNIEnv();

/* #line 779 "RStoJava.cweb" */
extern void *
s_to_java_basic(JNIEnv *env, USER_OBJECT_ obj, const char *sig,
		const char **actual_sig_ptr);

/* #line 860 "RStoJava.cweb" */
void *
convertToJava(JNIEnv *env, USER_OBJECT_ obj, jboolean isArray,
	      java_type whichType , long n) ;

/* #line 1115 "RStoJava.cweb" */
char *
getJavaSignature(USER_OBJECT_ obj, jboolean *isReference);

/* #line 1129 "RStoJava.cweb" */
USER_OBJECT_
javaToUserString(JNIEnv *env, jobject val);

/* #line 1153 "RStoJava.cweb" */
jclass
ManagerFindClass(JNIEnv *env, const char *className);

/* #line 1293 "RStoJava.cweb" */
extern boolean
s_catch_exception(JNIEnv *env, boolean asError);

/* #line 1376 "RStoJava.cweb" */
void
assignException(JNIEnv *env, jthrowable obj);

/* #line 1400 "RStoJava.cweb" */
void
throwRJavaError(JNIEnv *env, jthrowable exc);

void
RS_dput(USER_OBJECT_ obj);

/* #line 1434 "RStoJava.cweb" */
USER_OBJECT_
asOmegaReferenceUserObject(JNIEnv *env, jobject omegaObject, FuzzyBoolean isArray);

/* #line 1510 "RStoJava.cweb" */
FuzzyBoolean
isJavaObjectArray(JNIEnv *env, jobject obj, jstring className);
/* #line 1531 "RStoJava.cweb" */
USER_OBJECT_
createUserReferenceObject(JNIEnv *env, const char *SclassName, jstring value, jstring className, int isArray);

/* #line 1609 "RStoJava.cweb" */
jobject
userReferenceToJava(JNIEnv *env, USER_OBJECT_ obj, java_type which);

/* #line 1653 "RStoJava.cweb" */
jclass
RS_JAVA(getForeignReferenceClass)(USER_OBJECT_ obj, JNIEnv *env);

/* #line 1676 "RStoJava.cweb" */
int R_IS(USER_OBJECT_ obj, const char * const name);

/* #line 1704 "RStoJava.cweb" */
jboolean
RS_lockEvaluator(JNIEnv *env, jboolean on, jboolean announce);

/* #line 1760 "RStoJava.cweb" */
void
RS_JavaPolledEvents(void);

/* #line 1786 "RStoJava.cweb" */
void
RS_yieldEvaluator(JNIEnv *env);

/* #line 1804 "RStoJava.cweb" */
jobject
RS_getEvaluatorLock(JNIEnv *env);


/* #line 181 "RStoJava.cweb" */
#ifdef __cplusplus
extern "C" {
#endif

USER_OBJECT_
RS_genericJavaCall(USER_OBJECT_ qualifier, USER_OBJECT_ methodName,
                   USER_OBJECT_ userArgs,
                   USER_OBJECT_ userArgNames, USER_OBJECT_ returnValueName,
                   USER_OBJECT_ signatures, USER_OBJECT_ convert);

void
RS_JAVA(isJVMInitialized)();

/* #line 185 "RStoJava.cweb" */
#ifdef __cplusplus
                                        }
#endif

#define NAMED_JAVA_REFERENCE_SIG      "N"
#define ANONYMOUS_JAVA_REFERENCE_SIG  "A"
#define BASE_JAVA_REFERENCE_SIG       "R"

#define NAMED_R_REFERENCE_SIG      "W"
#define ANONYMOUS_R_REFERENCE_SIG  "X"

#define VMENV (*env)->

extern const char * const BaseOmegahatReferenceClass;
extern const char * const NamedOmegahatReferenceClass;
extern const char * const AnonymousOmegahatReferenceClass;

#endif


